#!/bin/bash
## role-ignore: basesystem

. /usr/share/univention-lib/admember.sh

if is_domain_in_admember_mode; then
	echo "Skipping test, domain is in AD member mode"
	exit 0
fi

is_s4_domain() {
	univention-ldapsearch -LLL "(&(univentionService=S4 Connector))" dn | grep -q '^dn: '
}



if ! is_s4_domain; then
	kinit --password-file=/etc/machine.secret "$(hostname)\$"
	univention-ldapsearch -Y GSSAPI cn=$(hostname) >/dev/null
fi
