#!/bin/bash

IMPACT="Windows clients will not apply GPOs without error"

test -e "$(which univention-s4search)" || exit 0

# trusts work with samba >= 4.10
if dpkg --compare-versions  $(dpkg-query -W -f '${Version}' "samba") gt 2:4.10; then
	exit 0
fi

. /usr/share/univention-lib/ucr.sh

trust_list=$(samba-tool domain trust list)
if grep -q '^Type' <<<"$trust_list"; then
	echo "ERROR: A domain trust has been configured"
	echo "==================================================="
	echo "$trust_list"
	echo "==================================================="
	exit 1
fi


