#!/bin/bash

. /usr/share/univention-lib/ucr.sh

eval "$(ucr shell hostname domainname)"

check_smbclient_via_krb5_keytab() {
	local rc
	kdestroy
	kinit -t /etc/krb5.keytab "${hostname^^}$" || return $?
	smbclient -k -L "$hostname.$domainname" >/dev/null 2>&1
	rc=$?
	kdestroy
	return "$rc"
}

# limit this test to DCs with Samba 4
if is_ucr_true 'samba4/autostart' && [ "$samba4_role" = "DC" ]; then
	check_smbclient_via_krb5_keytab
fi
