IMPACT="SID mismatch between ucs and samba my cause permission problems"

test -e "$(which univention-s4search)" || exit 0

eval "$(/usr/sbin/univention-config-registry shell server/role ldap/hostdn)"

rc=0
while read -d $'\0' ldif; do
	uid=$(sed -n 's/^sAMAccountName: \(.*\)/\1/p' <<<"$ldif")
	if [ -z "$uid" ]; then
		continue
	fi
	if [ "$server_role" = "domaincontroller_master" -o "$server_role" = "domaincontroller_backup" ]; then
		ucs_ldif=$(ldapsearch -xLLL -H ldapi:/// "(&(uid=$uid)(objectClass=univentionHost))" sambaSid)
	else
		ucs_ldif=$(ldapsearch -LLL -D "$ldap_hostdn" -y /etc/machine.secret "(&(uid=$uid)(objectClass=univentionHost))" sambaSid)
	fi
	ucs_dn=$(sed -n 's/^dn: \(.*\)/\1/p' <<<"$ucs_ldif")
	if [ -z "$ucs_dn" ]; then
		samba_dn=$(sed -n 's/^dn: \(.*\)/\1/p' <<<"$ldif")
		echo "OpenLDAP object missing for Samba/AD object: $samba_dn"
		rc=1
		continue
	fi

	ucs_sid=$(sed -n 's/^sambaSID: \(.*\)/\1/p' <<<"$ucs_ldif")
	samba_sid=$(sed -n 's/^objectSid: \(.*\)/\1/p' <<<"$ldif")
	if [ ! "$ucs_sid" = "$samba_sid" ]; then
		echo "SID diff for uid=$uid"
		echo "OpenLDAP: $ucs_sid"
		echo "Samba/AD: $samba_sid"
		rc=1
	fi
done < <(ldbsearch -H /var/lib/samba/private/sam.ldb  "(objectClass=computer)" objectSid sAMAccountName | sed "s/^$/\x00/")

exit "$rc"
